PF-build.sh 42 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_32
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to scrpit commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. #### Start check if OSTYPE is supported
  137. OS_FOUND=$( command -v uname)
  138. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  139. linux*)
  140. TARGET_OS="linux"
  141. ;;
  142. msys*|cygwin*|mingw*)
  143. # or possible 'bash on windows'
  144. TARGET_OS='windows'
  145. ;;
  146. nt|win*)
  147. TARGET_OS='windows'
  148. ;;
  149. *)
  150. TARGET_OS='unknown'
  151. ;;
  152. esac
  153. # Windows
  154. if [ $TARGET_OS == "windows" ]; then
  155. if [ $(uname -m) == "x86_64" ]; then
  156. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  157. Processor="64"
  158. elif [ $(uname -m) == "i386" ]; then
  159. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  160. Processor="32"
  161. else
  162. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  163. echo "Please refer to the notes of build.sh$(tput sgr0)"
  164. exit 1
  165. fi
  166. # Linux
  167. elif [ $TARGET_OS == "linux" ]; then
  168. if [ $(uname -m) == "x86_64" ]; then
  169. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  170. Processor="64"
  171. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  172. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  173. Processor="32"
  174. else
  175. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  176. echo "Please refer to the notes of build.sh$(tput sgr0)"
  177. exit 1
  178. fi
  179. else
  180. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  181. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  182. echo "Read the notes of build.sh$(tput sgr0)"
  183. exit 1
  184. fi
  185. sleep 2
  186. #### End check if OSTYPE is supported
  187. #### Prepare bash environment and check if wget, zip and other needed things are available
  188. # Check wget
  189. if ! type wget > /dev/null; then
  190. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  191. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  192. exit 2
  193. fi
  194. # Check for zip
  195. if ! type zip > /dev/null; then
  196. if [ $TARGET_OS == "windows" ]; then
  197. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  198. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  199. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  200. echo "Run git Bash under Administrator privilege and"
  201. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  202. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  203. exit 3
  204. elif [ $TARGET_OS == "linux" ]; then
  205. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  206. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  207. sudo apt-get update && apt-get install zip
  208. exit 3
  209. fi
  210. fi
  211. # Check python ... needed during language build
  212. if ! type python > /dev/null; then
  213. if [ $TARGET_OS == "windows" ]; then
  214. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  215. exit 4
  216. elif [ $TARGET_OS == "linux" ]; then
  217. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  218. echo "As Python 2.x will not be maintained from 2020 please,"
  219. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  220. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  221. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  222. sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  223. exit 4
  224. fi
  225. fi
  226. # Check gawk ... needed during language build
  227. if ! type gawk > /dev/null; then
  228. if [ $TARGET_OS == "linux" ]; then
  229. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  230. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  231. sudo apt-get update && apt-get install gawk
  232. exit 4
  233. fi
  234. fi
  235. #### End prepare bash / Linux environment
  236. #### Set build environment
  237. ARDUINO_ENV="1.8.5"
  238. BUILD_ENV="1.0.6"
  239. BOARD="prusa_einsy_rambo"
  240. BOARD_PACKAGE_NAME="PrusaResearch"
  241. BOARD_VERSION="1.0.3"
  242. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  243. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  244. BOARD_FILENAME="prusa3dboards"
  245. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  246. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  247. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  248. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  249. LIB="PrusaLibrary"
  250. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  251. # List few useful data
  252. echo
  253. echo "Script path :" $SCRIPT_PATH
  254. echo "OS :" $OS
  255. echo "OS type :" $TARGET_OS
  256. echo ""
  257. echo "Ardunio IDE :" $ARDUINO_ENV
  258. echo "Build env :" $BUILD_ENV
  259. echo "Board :" $BOARD
  260. echo "Package name:" $BOARD_PACKAGE_NAME
  261. echo "Board v. :" $BOARD_VERSION
  262. echo "Specific Lib:" $LIB
  263. echo ""
  264. #### Start prepare building environment
  265. #Check if build exists and creates it if not
  266. if [ ! -d "../PF-build-dl" ]; then
  267. mkdir ../PF-build-dl || exit 5
  268. fi
  269. cd ../PF-build-dl || exit 6
  270. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  271. # Check if PF-build-env-<version> exists and downloads + creates it if not
  272. # The build environment is based on the supported Arduino IDE portable version with some changes
  273. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  274. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  275. mkdir ../PF-build-env-$BUILD_ENV
  276. sleep 5
  277. fi
  278. # Download and extract supported Arduino IDE depending on OS
  279. # Windows
  280. if [ $TARGET_OS == "windows" ]; then
  281. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  282. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  283. sleep 2
  284. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  285. echo "$(tput sgr 0)"
  286. fi
  287. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  288. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  289. sleep 2
  290. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  291. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  292. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  293. echo "$(tput sgr0)"
  294. fi
  295. fi
  296. # Linux
  297. if [ $TARGET_OS == "linux" ]; then
  298. # 32 or 64 bit version
  299. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  300. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  301. sleep 2
  302. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  303. echo "$(tput sgr 0)"
  304. fi
  305. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  306. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  307. sleep 2
  308. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  309. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  310. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  311. echo "$(tput sgr0)"
  312. fi
  313. fi
  314. # Make Arduino IDE portable
  315. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  316. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  317. fi
  318. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  319. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  320. fi
  321. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  322. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  323. fi
  324. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  325. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  326. fi
  327. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  328. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  329. fi
  330. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  331. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  332. fi
  333. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  334. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  335. fi
  336. # Change Arduino IDE preferences
  337. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  338. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  339. sleep 2
  340. echo "update.check"
  341. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  342. echo "board"
  343. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  344. echo "editor.linenumbers"
  345. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  346. echo "boardsmanager.additional.urls"
  347. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  348. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  349. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  350. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  351. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  352. echo "$(tput sgr0)"
  353. fi
  354. # Download and extract Prusa Firmware related parts
  355. # Download and extract PrusaResearchRambo board
  356. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  357. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  358. sleep 2
  359. wget $BOARD_FILE_URL || exit 9
  360. fi
  361. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  362. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  363. sleep 2
  364. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  365. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  366. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  367. fi
  368. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  369. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  370. fi
  371. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  372. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  373. fi
  374. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  375. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  376. fi
  377. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  378. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  379. echo "$(tput sgr 0)"
  380. fi
  381. # Download and extract Prusa Firmware specific library files
  382. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  383. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  384. sleep 2
  385. wget $PF_BUILD_FILE_URL || exit 11
  386. echo "$(tput sgr 0)"
  387. fi
  388. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  389. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  390. sleep 2
  391. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  392. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  393. echo "$(tput sgr0)"
  394. fi
  395. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  396. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  397. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  398. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  399. sleep 2
  400. fi
  401. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  402. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  403. sleep 2
  404. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  405. sleep 2
  406. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  407. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  408. echo "$(tput sgr0)"
  409. fi
  410. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  411. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  412. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  413. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  414. sleep 2
  415. echo "$(tput sgr0)"
  416. exit 13
  417. fi
  418. #### End prepare building
  419. #### Start
  420. cd $SCRIPT_PATH
  421. # Check if git is availible
  422. if type git > /dev/null; then
  423. git_availible="1"
  424. fi
  425. #arguments
  426. #'-v' Variant "All" or variant file name
  427. #'-l' Languages "ALL" for multi language or "EN_ONLY" for english only
  428. #'-d' Devel build "GOLD", "RC", "BETA", "ALPHA", "DEBUG", "DEVEL" and "UNKNOWN"
  429. #'-b' Build/commit number "Auto" needs git or a number
  430. #'-o' Output "1" force or "0" block output and delays
  431. while getopts v:l:d:b:o: flag
  432. do
  433. case "${flag}" in
  434. v) variant_flag=${OPTARG};;
  435. l) language_flag=${OPTARG};;
  436. d) devel_flag=${OPTARG};;
  437. b) build_flag=${OPTARG};;
  438. o) output_flag=${OPTARG};;
  439. esac
  440. done
  441. #echo "variant_flag: $variant_flag";
  442. #echo "language_flag: $language_flag";
  443. #echo "devel_flag: $devel_flag";
  444. #echo "build_flag: $build_flag";
  445. #echo "output_flag: $output_flag";
  446. #
  447. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  448. if [ -z "$variant_flag" ] ; then
  449. # Select which variant of the Prusa Firmware will be compiled, like
  450. PS3="Select a variant: "
  451. while IFS= read -r -d $'\0' f; do
  452. options[i++]="$f"
  453. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  454. select opt in "${options[@]}" "All" "Quit"; do
  455. case $opt in
  456. *.h)
  457. VARIANT=$(basename "$opt" ".h")
  458. VARIANTS[i++]="$opt"
  459. break
  460. ;;
  461. "All")
  462. VARIANT="All"
  463. VARIANTS=${options[*]}
  464. break
  465. ;;
  466. "Quit")
  467. echo "You chose to stop"
  468. exit 20
  469. ;;
  470. *)
  471. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  472. ;;
  473. esac
  474. done
  475. else
  476. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  477. VARIANTS=$variant_flag
  478. elif [ "$variant_flag" == "All" ] ; then
  479. while IFS= read -r -d $'\0' f; do
  480. options[i++]="$f"
  481. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  482. VARIANT="All"
  483. VARIANTS=${options[*]}
  484. else
  485. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  486. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  487. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  488. echo "$(tput sgr0)"
  489. exit 21
  490. fi
  491. fi
  492. #'-l' argument defines if it is an english only version. Known values EN_ONLY / ALL
  493. #Check default language mode
  494. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  495. if [ -z "$language_flag" ] ; then
  496. PS3="Select a language: "
  497. echo
  498. echo "Which lang-build do you want?"
  499. select yn in "Multi languages" "English only"; do
  500. case $yn in
  501. "Multi languages")
  502. LANGUAGES="ALL"
  503. break
  504. ;;
  505. "English only")
  506. LANGUAGES="EN_ONLY"
  507. break
  508. ;;
  509. *)
  510. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  511. ;;
  512. esac
  513. done
  514. else
  515. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  516. LANGUAGES=$language_flag
  517. else
  518. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  519. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  520. exit 22
  521. fi
  522. fi
  523. #Check if DEV_STATUS is selected via argument '-d'
  524. if [ ! -z "$devel_flag" ] ; then
  525. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  526. DEV_STATUS_SELECTED=$devel_flag
  527. else
  528. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  529. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  530. exit 23
  531. fi
  532. fi
  533. #Check if Build is selected via argument '-b'
  534. if [ ! -z "$build_flag" ] ; then
  535. if [[ "$build_flag" == "Auto" && "$git_availible" == "1" ]] ; then
  536. echo "Build changed to $build_flag"
  537. BUILD=$(git rev-list --count HEAD)
  538. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  539. BUILD=$build_flag
  540. else
  541. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  542. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  543. exit 24
  544. fi
  545. echo "New Build number is: $BUILD"
  546. fi
  547. # check if script has been started with arguments
  548. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  549. OUTPUT=1
  550. else
  551. OUTPUT=0
  552. fi
  553. #echo "Output is:" $OUTPUT
  554. #Check git branch has changed
  555. if [ ! -z "git_availible" ]; then
  556. BRANCH=""
  557. CLEAN_PF_FW_BUILD=0
  558. else
  559. BRANCH=$(git branch --show-current)
  560. echo "Current branch is:" $BRANCH
  561. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  562. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  563. echo "created PF-build.branch file"
  564. else
  565. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  566. echo "Previous branch was:" $PRE_BRANCH
  567. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  568. CLEAN_PF_FW_BUILD=1
  569. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  570. fi
  571. fi
  572. fi
  573. #Set BUILD_ENV_PATH
  574. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  575. BUILD_ENV_PATH="$( pwd -P )"
  576. cd ../..
  577. #Checkif BUILD_PATH exists and if not creates it
  578. if [ ! -d "Prusa-Firmware-build" ]; then
  579. mkdir Prusa-Firmware-build || exit 26
  580. fi
  581. #Set the BUILD_PATH for Arduino IDE
  582. cd Prusa-Firmware-build || exit 27
  583. BUILD_PATH="$( pwd -P )"
  584. #Check git branch has changed
  585. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  586. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  587. rm -r *
  588. else
  589. echo "Nothing to clean up"
  590. fi
  591. for v in ${VARIANTS[*]}
  592. do
  593. VARIANT=$(basename "$v" ".h")
  594. # Find firmware version in Configuration.h file and use it to generate the hex filename
  595. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  596. if [ -z "$BUILD" ] ; then
  597. # Find build version in Configuration.h file and use it to generate the hex filename
  598. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  599. else
  600. # Find and replace build version in Configuration.h file
  601. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  602. echo "Original build number: $BUILD_ORG"
  603. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  604. fi
  605. # Check if the motherboard is an EINSY and if so only one hex file will generated
  606. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  607. # Check development status
  608. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  609. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  610. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  611. DEV_STATUS="RC"
  612. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  613. DEV_STATUS="ALPHA"
  614. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  615. DEV_STATUS="BETA"
  616. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  617. DEV_STATUS="DEVEL"
  618. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  619. DEV_STATUS="DEBUG"
  620. else
  621. DEV_STATUS="UNKNOWN"
  622. echo
  623. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  624. PS3="Select YES only if source code is tested and trusted: "
  625. select yn in "Yes" "No"; do
  626. case $yn in
  627. Yes)
  628. DEV_STATUS="GOLD"
  629. DEV_STATUS_SELECTED="GOLD"
  630. break
  631. ;;
  632. No)
  633. DEV_STATUS="UNKNOWN"
  634. DEV_STATUS_SELECTED="UNKNOWN"
  635. break
  636. ;;
  637. *)
  638. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  639. ;;
  640. esac
  641. done
  642. fi
  643. else
  644. DEV_STATUS=$DEV_STATUS_SELECTED
  645. fi
  646. #Prepare hex files folders
  647. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  648. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  649. fi
  650. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  651. #Check if exactly the same hexfile already exists
  652. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  653. echo ""
  654. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  655. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  656. if [ $OUTPUT == "1" ] ; then
  657. read -t 10 -p "Press Enter to continue..."
  658. fi
  659. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  660. echo ""
  661. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  662. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  663. if [ $OUTPUT == "1" ] ; then
  664. read -t 10 -p "Press Enter to continue..."
  665. fi
  666. fi
  667. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  668. echo ""
  669. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  670. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  671. if [ $OUTPUT == "1" ] ; then
  672. read -t 10 -p "Press Enter to continue..."
  673. fi
  674. fi
  675. #List some useful data
  676. echo "$(tput setaf 2)$(tput setab 7) "
  677. echo "Variant :" $VARIANT
  678. echo "Firmware :" $FW
  679. echo "Build # :" $BUILD
  680. echo "Dev Check :" $DEV_CHECK
  681. echo "DEV Status :" $DEV_STATUS
  682. echo "Motherboard:" $MOTHERBOARD
  683. echo "Languages :" $LANGUAGES
  684. echo "Hex-file Folder:" $OUTPUT_FOLDER
  685. echo "$(tput sgr0)"
  686. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  687. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  688. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  689. else
  690. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  691. if [ $OUTPUT == "1" ] ; then
  692. read -t 10 -p "Press Enter to continue..."
  693. fi
  694. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  695. fi
  696. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  697. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  698. # set FW_REPOSITORY
  699. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  700. #Prepare english only or multilanguage version to be build
  701. if [ $LANGUAGES == "EN_ONLY" ]; then
  702. echo " "
  703. echo "English only language firmware will be built"
  704. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  705. echo " "
  706. else
  707. echo " "
  708. echo "Multi-language firmware will be built"
  709. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  710. echo " "
  711. fi
  712. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  713. # if [ $TARGET_OS == "windows" ]; then
  714. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  715. # fi
  716. #### End of Prepare building
  717. #### Start building
  718. export ARDUINO=$BUILD_ENV_PATH
  719. #echo $BUILD_ENV_PATH
  720. #export BUILDER=$ARDUINO/arduino-builder
  721. echo
  722. #read -t 5 -p "Press Enter..."
  723. echo
  724. echo "Start to build Prusa Firmware ..."
  725. echo "Using variant $VARIANT$(tput setaf 3)"
  726. if [ $OUTPUT == "1" ] ; then
  727. sleep 2
  728. fi
  729. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  730. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  731. echo "$(tput sgr 0)"
  732. if [ $LANGUAGES == "ALL" ]; then
  733. echo "$(tput setaf 2)"
  734. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  735. echo "$(tput sgr 0)"
  736. if [ $OUTPUT == "1" ] ; then
  737. sleep 2
  738. fi
  739. cd $SCRIPT_PATH/lang
  740. echo "$(tput setaf 3)"
  741. ./config.sh || exit 31
  742. echo "$(tput sgr 0)"
  743. # Check if previous languages and firmware build exist and if so clean them up
  744. if [ -f "lang_en.tmp" ]; then
  745. echo ""
  746. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  747. if [ $OUTPUT == "1" ] ; then
  748. read -t 10 -p "Press Enter to continue..."
  749. fi
  750. echo "$(tput setaf 3)"
  751. ./lang-clean.sh
  752. echo "$(tput sgr 0)"
  753. fi
  754. if [ -f "progmem.out" ]; then
  755. echo ""
  756. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  757. if [ $OUTPUT == "1" ] ; then
  758. read -t 10 -p "Press Enter to continue..."
  759. fi
  760. echo "$(tput setaf 3)"
  761. ./fw-clean.sh
  762. echo "$(tput sgr 0)"
  763. fi
  764. # build languages
  765. echo "$(tput setaf 3)"
  766. ./lang-build.sh || exit 32
  767. # Combine compiled firmware with languages
  768. ./fw-build.sh || exit 33
  769. cp not_tran.txt not_tran_$VARIANT.txt
  770. cp not_used.txt not_used_$VARIANT.txt
  771. echo "$(tput sgr 0)"
  772. # Check if the motherboard is an EINSY and if so only one hex file will generated
  773. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  774. # If the motherboard is an EINSY just copy one hexfile
  775. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  776. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  777. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  778. else
  779. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  780. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  781. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  782. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  783. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  784. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  785. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  786. if [ $TARGET_OS == "windows" ]; then
  787. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  788. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  789. elif [ $TARGET_OS == "linux" ]; then
  790. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  791. fi
  792. fi
  793. # Cleanup after build
  794. echo "$(tput setaf 3)"
  795. ./fw-clean.sh || exit 34
  796. ./lang-clean.sh || exit 35
  797. echo "$(tput sgr 0)"
  798. else
  799. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  800. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  801. fi
  802. # Cleanup Firmware
  803. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  804. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  805. then
  806. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  807. fi
  808. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  809. then
  810. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  811. fi
  812. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  813. then
  814. rm $SCRIPT_PATH/lang/not_tran.txt
  815. fi
  816. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  817. then
  818. rm $SCRIPT_PATH/lang/not_used.txt
  819. fi
  820. # Restore files to previous state
  821. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  822. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  823. if [ ! -z "$BUILD_ORG" ] ; then
  824. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  825. fi
  826. echo $MULTI_LANGUAGE_CHECK
  827. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  828. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  829. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  830. if [ $OUTPUT == "1" ] ; then
  831. sleep 5
  832. fi
  833. done
  834. # Switch to hex path and list build files
  835. cd $SCRIPT_PATH
  836. cd ..
  837. echo "$(tput setaf 2) "
  838. echo " "
  839. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  840. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  841. #### End building